#include <config.h>

#include "header.h"
#include <stdlib.h>

#include "omassert.h"

// FIXME Upgrade to newer snowball which checks return values from malloc
// and calloc.
extern struct SN_env * SN_create_env(int S_size, int I_size, int B_size)
{   struct SN_env * z;
    z = reinterpret_cast<struct SN_env *>(calloc(1, sizeof(struct SN_env)));
    if (z == NULL) {
	throw Xapian::InternalError("calloc failed to allocate "STRINGIZE(sizeof(struct SN_env))" bytes");
    }
    z->p = create_s();
    if (S_size) {
	z->S = reinterpret_cast<symbol **>(malloc(S_size * sizeof(symbol *)));
	if (z->S == NULL) {
	    throw Xapian::InternalError("malloc failed");
	}
	for (int i = 0; i < S_size; i++) z->S[i] = create_s();
	z->S_size = S_size;
    }

    if (I_size) {
	z->I = reinterpret_cast<int *>(calloc(I_size, sizeof(int)));
	if (z->I == NULL) {
	    throw Xapian::InternalError("calloc failed");
	}
	z->I_size = I_size;
    }

    if (B_size) {
	z->B = reinterpret_cast<symbol *>(calloc(B_size, sizeof(symbol)));
	if (z->B == NULL) {
	    throw Xapian::InternalError("calloc failed");
	}
	z->B_size = B_size;
    }

    return z;
}

extern void SN_close_env(struct SN_env * z)
{
    if (z->S_size) {
	for (int i = 0; i < z->S_size; i++) lose_s(z->S[i]);
	free(z->S);
    }
    if (z->I_size) free(z->I);
    if (z->B_size) free(z->B);
    if (z->p) lose_s(z->p);
    free(z);
}

extern void SN_set_current(struct SN_env * z, int size, const symbol * s)
{
    replace_s(z, 0, z->l, size, s);
    z->c = 0;
}
